// Connection.java
// socket connection base class.

package JP.gr.java_conf.tech.net;

import java.io.*;
import java.net.*;

/**
	Socketڑ̊bIȃNX

	@version	1.01	09/17/1999
	@author		Takahiro Shigemoto
*/
public class Connection
{
	private Socket socket;			// \Pbg
	private boolean close_flag;		// ڑĂ邩ǂ

	InputStream		input;			// BynaryMpXg[
	OutputStream	output;			// BynaryMpXg[

	/**
		zXgƃ|[gw肵ĐڑB
		@param	host_name	ڑ̃zXgl[
		@param	port		ڑ̃|[g
	*/
	public Connection(String host_name, int port)
	{
		try
		{
			// Socket̍\z
			socket = new Socket(host_name, port);

			// I/OXg[̍\z
			input  = socket.getInputStream();
			output = socket.getOutputStream();
		}
		catch(UnknownHostException uh_ex)
		{
			System.err.println(uh_ex);
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
		}

		close_flag = false;
	}

	/**
		K[x[WRN^ɂĉ鎞ɌĂ΂B
	*/
	protected void finalize()
	{
		if(!close_flag)
			connectionClose();
	}

	/**
		Socket̃CX^X𓾂B
		@return	Socket̃CX^X
	*/
	public Socket getConnectionSocket()
	{
		return(socket);
	}

	/**
		IPAhX𓾂B
		@return	ڑIPAhX
	*/
	public InetAddress getConnectionSockaddr()
	{
		return(socket.getInetAddress());
	}

	/**
		ڑB
	*/
	public void connectionClose()
	{
		try
		{
			socket.close();
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
		}
		close_flag = true;
	}

	/**
		Bytef[^𑗂B
		@param	buf		Mf[^i[ꂽoCgz
		@param	offset	Mʒu
		@param	len		M钷

		@return	Mɐ0AsȂ-1ԂB
	*/
	public int send(byte buf[], int offset, int len)
	{
		try
		{
			output.write(buf, offset, len);
			output.flush();

			return(0);
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
			return(-1);
		}
	}

	/**
		Bytef[^󂯎B
		@param	buf		Mf[^i[oCgz
		@param	offset	Mʒu
		@param	len		M钷

		@return	MɐΎMAsȂ-1ԂB
	*/
	public int recv(byte buf[],int offset,int len)
	{
		try
		{
			InputStream input = socket.getInputStream();

			return(input.read(buf, offset, len));
		}
		catch(IOException io_ex)
		{
			System.err.println(io_ex);
			return(-1);
		}
	}

	/**
		TimeOutԂݒ肷B
		@param	time	TimeOut(~bP)
	*/
	protected void setSoTimeout(int time)
	{
		try
		{
			socket.setSoTimeout(time);
		}
		catch(SocketException s_ex)
		{
			s_ex.printStackTrace();
		}
	}
}